<?php

namespace App\Services\Customer;

use App\Entities\Customer\AccountEntity;
use App\Models\Customer\AccountModel;
use App\Entities\Customer\ClientEntity;

class AccountService extends CustomerService
{
    public function __construct()
    {
        parent::__construct(new AccountModel());
        $this->addClassName('Account');
    }
    public function getFormFields(): array
    {
        return [
            'fields' => [
                "clientinfo_uid",
                "bank",
                "title",
                "alias",
                "issue_at",
                "amount",
                "status",
            ],
            'filters' => [
                "clientinfo_uid",
                "bank",
                "status",
            ],
        ];
    }
    public function getIndexFields(): array
    {
        return [
            'fields' => [
                "clientinfo_uid",
                "bank",
                "title",
                "alias",
                "issue_at",
                "amount",
                "status",
            ],
            'filters' => [
                "clientinfo_uid",
                "bank",
                "status",
            ],
        ];
    }
    public function getBatchjobFields(): array
    {
        return ['status'];
    }
    //기본 기능부분

    //고객예치금처리
    private function setBalance(array $formDatas): void
    {
        //account_balance 체크
        $entity = $this->getClientService()->getEntity($formDatas['clientinfo_uid']);
        if (!$entity) {
            throw new \Exception("{$formDatas['clientinfo_uid']}에 대한 고객정보를 찾을수 없습니다.");
        }
        $amount = intval($formDatas['amount']);
        // dd($formDatas);
        if ($formDatas['status'] === AccountEntity::DEFAULT_STATUS) { //입금, 쿠폰추가
            $entity = $this->getClientService()->deposit($entity, 'account_balance',   $amount);
        } else { // 출금, 쿠폰사용
            $entity = $this->getClientService()->withdrawal($entity, 'account_balance',   $amount);
        }
    }
    public function create(array $formDatas): AccountEntity
    {
        $this->setBalance($formDatas);
        return parent::create($formDatas);
    }
    //List 검색용
    public function index_condition_filterWord(string $word): void
    {
        $this->getModel()->orLike($this->getModel()->getTable() . '.alias', $word, 'both');
        parent::index_condition_filterWord($word);
    }
}
